'use strict';

//是否合并了js代码
var isMergeJS = true;

window.onSubProjectReady = function( a ) {
    let o = {};
    function i(r) {
        if (!o[r]) {
            if (!a[r]) {
                console.warn("Cannot find module:" + r);
                return null;
            }
            var p = o[r] = {
                exports: {}
            };
            a[r].call(p.exports, function (e) {
                return i(e)
            }, p, p.exports)
        }
        return o[r].exports
    }
    let l = Object.keys( a ).length
    for (var r = 0; r < l; r++)
        i(r);
    return i
}
window._g_E = function () { var t = function (e, o) { return (t = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (t, e) { t.__proto__ = e } || function (t, e) { for (var o in e) e.hasOwnProperty(o) && (t[o] = e[o]) })(e, o) }; return function (e, o) { function i() { this.constructor = e } t(e, o), e.prototype = null === o ? Object.create(o) : (i.prototype = o.prototype, new i) } }();
window._g_D = function (e, t, o, n) { var i, s = arguments.length, r = s < 3 ? t : null === n ? n = Object.getOwnPropertyDescriptor(t, o) : n; if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) r = Reflect.decorate(e, t, o, n); else for (var a = e.length - 1; a >= 0; a--)(i = e[a]) && (r = (s < 3 ? i(r) : s > 3 ? i(t, o, r) : i(t, o)) || r); return s > 3 && r && Object.defineProperty(t, o, r), r };
window._g_W = function (t, e, o, i) { return new (o || (o = Promise))(function (n, s) { function r(t) { try { c(i.next(t)) } catch (t) { s(t) } } function a(t) { try { c(i.throw(t)) } catch (t) { s(t) } } function c(t) { t.done ? n(t.value) : new o(function (e) { e(t.value) }).then(r, a) } c((i = i.apply(t, e || [])).next()) }) };
window._g_G = function (e, t) { var o, n, i, s, r = { label: 0, sent: function () { if (1 & i[0]) throw i[1]; return i[1] }, trys: [], ops: [] }; return s = { next: a(0), throw: a(1), return: a(2) }, "function" == typeof Symbol && (s[Symbol.iterator] = function () { return this }), s; function a(e) { return function (t) { return l([e, t]) } } function l(s) { if (o) throw new TypeError("Generator is already executing."); for (; r;)try { if (o = 1, n && (i = 2 & s[0] ? n.return : s[0] ? n.throw || ((i = n.return) && i.call(n), 0) : n.next) && !(i = i.call(n, s[1])).done) return i; switch (n = 0, i && (s = [2 & s[0], i.value]), s[0]) { case 0: case 1: i = s; break; case 4: return r.label++, { value: s[1], done: !1 }; case 5: r.label++, n = s[1], s = [0]; continue; case 7: s = r.ops.pop(), r.trys.pop(); continue; default: if (!(i = (i = r.trys).length > 0 && i[i.length - 1]) && (6 === s[0] || 2 === s[0])) { r = 0; continue } if (3 === s[0] && (!i || s[1] > i[0] && s[1] < i[3])) { r.label = s[1]; break } if (6 === s[0] && r.label < i[1]) { r.label = i[1], i = s; break } if (i && r.label < i[2]) { r.label = i[2], r.ops.push(s); break } i[2] && r.ops.pop(), r.trys.pop(); continue }s = t.call(e, r) } catch (e) { s = [6, e], n = 0 } finally { o = i = 0 } if (5 & s[0]) throw s[1]; return { value: s[0] ? s[1] : void 0, done: !0 } } };

window.boot = function () {
    var hotUpdateSearchPaths = localStorage.getItem('HotUpdateSearchPaths');
    if (hotUpdateSearchPaths) {
        jsb.fileUtils.setSearchPaths(JSON.parse(hotUpdateSearchPaths));
    }

    var settings = window._CCSettings;
    // window._CCSettings = undefined;

    if (!settings.debug) {
        var uuids = settings.uuids;

        var rawAssets = settings.rawAssets;
        var assetTypes = settings.assetTypes;
        var realRawAssets = settings.rawAssets = {};
        for (var mount in rawAssets) {
            var entries = rawAssets[mount];
            var realEntries = realRawAssets[mount] = {};
            for (var id in entries) {
                var entry = entries[id];
                var type = entry[1];
                // retrieve minified raw asset
                if (typeof type === 'number') {
                    entry[1] = assetTypes[type];
                }
                // retrieve uuid
                realEntries[uuids[id] || id] = entry;
            }
        }

        var scenes = settings.scenes;
        for (var i = 0; i < scenes.length; ++i) {
            var scene = scenes[i];
            if (typeof scene.uuid === 'number') {
                scene.uuid = uuids[scene.uuid];
            }
        }

        var packedAssets = settings.packedAssets;
        for (var packId in packedAssets) {
            var packedIds = packedAssets[packId];
            for (var j = 0; j < packedIds.length; ++j) {
                if (typeof packedIds[j] === 'number') {
                    packedIds[j] = uuids[packedIds[j]];
                }
            }
        }

        var subpackages = settings.subpackages;
        for (var subId in subpackages) {
            var uuidArray = subpackages[subId].uuids;
            if (uuidArray) {
                for (var k = 0, l = uuidArray.length; k < l; k++) {
                    if (typeof uuidArray[k] === 'number') {
                        uuidArray[k] = uuids[uuidArray[k]];
                    }
                }
            }
        }
    }

    var onStart = function onStart() {
        cc.loader.downloader._subpackages = settings.subpackages;

        cc.view.enableRetina(true);
        cc.view.resizeWithBrowserSize(true);

        if (cc.sys.isMobile) {
            if (settings.orientation === 'landscape') {
                cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
            } else if (settings.orientation === 'portrait') {
                cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
            }
            cc.view.enableAutoFullScreen([cc.sys.BROWSER_TYPE_BAIDU, cc.sys.BROWSER_TYPE_WECHAT, cc.sys.BROWSER_TYPE_MOBILE_QQ, cc.sys.BROWSER_TYPE_MIUI].indexOf(cc.sys.browserType) < 0);
        }

        function loadScene(launchScene) {
            cc.director.loadScene(launchScene, function (err) {
                if (!err) {
                    cc.loader.onProgress = null;
                    console.log('Success to load scene: ' + launchScene);
                } else if (CC_BUILD) {
                    setTimeout(function () {
                        loadScene(launchScene);
                    }, 1000);
                }
            });
        }
        var launchScene = settings.launchScene;
        // load scene
        loadScene(launchScene);
    };

    // jsList
    var jsList = null;
    if (isMergeJS) {
        jsList = ["src/project.js"];
    } else {
        jsList = settings.jsList;
        var bundledScript = settings.debug ? 'src/project.dev.js' : 'src/project.js';
        if (jsList) {
            jsList = jsList.map(function (x) {
                return 'src/' + x;
            });
            jsList.push(bundledScript);
        } else {
            jsList = [bundledScript];
        }
    }
    var option = {
        id: 'GameCanvas',
        scenes: settings.scenes,
        debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
        showFPS: settings.debug,
        frameRate: 60,
        jsList: jsList,
        groupList: settings.groupList,
        collisionMatrix: settings.collisionMatrix
    };

    // init assets
    cc.AssetLibrary.init({
        libraryPath: 'res/import',
        rawAssetsBase: 'res/raw-',
        rawAssets: settings.rawAssets,
        packedAssets: settings.packedAssets,
        md5AssetsMap: settings.md5AssetsMap,
        subpackages: settings.subpackages
    });

    cc.game.run(option, onStart);
};

if (window.jsb) {
    require('src/settings.js');
    require('src/cocos2d-jsb.js');
    if (!isMergeJS) {
        require('jsb-adapter/jsb-engine.js');
    }
    var old_NodeProxy_init = renderer.NodeProxy.prototype.init;
    renderer.NodeProxy.prototype.init = function (owner) {
        //重要，这个标志位决定是否要渲染，但是复用后有可能有残留，当某个对象在onEnable之前就被停用，则有可能不会更新
        owner._spaceInfo.dirty[0] = 1;
        old_NodeProxy_init.call(this, owner);
    };
    cc.macro.CLEANUP_IMAGE_CACHE = false;
    window.boot();
}
